# coding: utf-8
document = <<DOC
Hatch marks (also called hash marks or tick marks) are a form of mathematical notation. They are used in three ways:

    Unit and value marks — as on a ruler or number line
    Congruency notation — as on a geometric figure
    Graphed points — as on a graph

Hatch marks are frequently used as an abbreviation of some common units of measurement. In regard to distance, a single hatch mark indicates feet, and two hash marks indicate inches. In regard to time, a single hatch mark indicates minutes, and two hatch marks indicate seconds. In geometry and trigonometry, such marks are used following an elevated circle to indicate degrees, minutes, and seconds
DOC

def words_from_string(string)
  string.downcase.scan(/[\w']+/)
end

def count_words(words)
  counts = {}
  for word in words
    if counts.has_key?(word)
      counts[word] += 1
    else
      counts[word] = 1
    end
  end
  counts
end

def easy_count_words(words)
  counts = Hash.new(0)
  for word in words
    counts[word] += 1
  end
  counts
end

counts = easy_count_words(words_from_string(document))
#p counts
sorted = counts.sort_by { |word, count| count }
#p sorted
top_five = sorted.last(5)
puts "Top five words are"
for i in 0...top_five.length
  puts "Word: \"#{top_five[i][0]}\", count: #{top_five[i][1]}"
end

puts "Another time top five"
top_five.each do |word, count|
  puts "Word: \"#{word}\", count: #{count}"
end
